package hu.elte.apriori.orai;

import java.io.IOException;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.fs.FileSystem;
import org.apache.hadoop.fs.Path;
import org.apache.hadoop.io.IntWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.Job;
import org.apache.hadoop.mapreduce.lib.input.FileInputFormat;
import org.apache.hadoop.mapreduce.lib.input.NLineInputFormat;
import org.apache.hadoop.mapreduce.lib.output.FileOutputFormat;

public class ApriOraiDriver {

	public static void main(String[] args) throws Exception {
		Configuration conf = new Configuration();
		
		conf.setInt(NLineInputFormat.LINES_PER_MAP, 10);
		
		Job job = Job.getInstance(conf, "JobName");
		job.setJarByClass(hu.elte.apriori.orai.ApriOraiDriver.class);
		job.setMapperClass(hu.elte.apriori.orai.ApriOraiMapper.class);
		//job.setNumReduceTasks(0);

		job.setReducerClass(hu.elte.apriori.orai.ApriOraiReducer.class);
		
		job.setInputFormatClass(NLineInputFormat.class);

		// TODO: specify output types
		job.setOutputKeyClass(Text.class);
		job.setOutputValueClass(IntWritable.class);

		// TODO: specify input and output DIRECTORIES (not files)
		FileInputFormat.setInputPaths(job, new Path("aprioriInput"));
		FileOutputFormat.setOutputPath(job, new Path("apriOraiOut"));
		
		FileSystem fs;
		try {
			fs = FileSystem.get(conf);
			if (fs.exists(new Path("apriOraiOut")))
				fs.delete(new Path("apriOraiOut"),true);
		} catch (IOException e1) {
			e1.printStackTrace();
		}

		if (!job.waitForCompletion(true))
			return;
	}

}
