package hu.elte.apriori.orai;

import java.io.IOException;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.apache.hadoop.io.IntWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.Reducer;

public class ApriOraiReducer extends Reducer<Text, IntWritable, Text, IntWritable> {
	private HashMap<String,Integer> items = new HashMap<String, Integer>();
	private IntWritable sum = new IntWritable(); 
	
	public void setup(Context context) {
		items = new HashMap<String, Integer>();
	}
	
	public void reduce(Text _key, Iterable<IntWritable> values, Context context) throws IOException, InterruptedException {
		// process values
		int s = 0;
		for (IntWritable val : values) {
			s += val.get();
		}
		items.put(_key.toString(), s);
	}

	public void cleanup(Context context) throws IOException, InterruptedException {
		Map<Integer, String> map = sortByValues(items);
		Set<Entry<Integer, String>> set2 = map.entrySet();
	    Iterator<Entry<Integer, String>> iterator2 = set2.iterator();
	    while(iterator2.hasNext()) {
	           Map.Entry me2 = (Map.Entry)iterator2.next();
	           sum.set((int)me2.getValue());
	           context.write(new Text((String)me2.getKey()), sum );
	    }
		
	}
	
	private static HashMap sortByValues(HashMap map) { 
	       List list = new LinkedList(map.entrySet());
	       // Defined Custom Comparator here
	       Collections.sort(list, new Comparator() {
	            public int compare(Object o1, Object o2) {
	               return ((Comparable) ((Map.Entry) (o1)).getValue())
	                  .compareTo(((Map.Entry) (o2)).getValue());
	            }
	       });

	       // Here I am copying the sorted list in HashMap
	       // using LinkedHashMap to preserve the insertion order
	       HashMap sortedHashMap = new LinkedHashMap();
	       for (Iterator it = list.iterator(); it.hasNext();) {
	              Map.Entry entry = (Map.Entry) it.next();
	              sortedHashMap.put(entry.getKey(), entry.getValue());
	       } 
	       return sortedHashMap;
	  }
	
}
