package hu.elte.orai.matrix;

import java.io.IOException;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.fs.FileSystem;
import org.apache.hadoop.fs.Path;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.Job;
import org.apache.hadoop.mapreduce.lib.input.FileInputFormat;
import org.apache.hadoop.mapreduce.lib.output.FileOutputFormat;

public class OraiMatrixDriver {

	public static void main(String[] args) throws Exception {
		Configuration conf = new Configuration();
		conf.set("left", "A.txt");
		conf.set("right", "B.txt");
		conf.set("Anxm", "2x3");
		conf.set("Bnxm", "2x2");
		
		Job job = Job.getInstance(conf, "MatrixOrai");
		job.setJarByClass(hu.elte.orai.matrix.OraiMatrixDriver.class);
		job.setMapperClass(hu.elte.orai.matrix.OraiMatrixMapper.class);

		job.setReducerClass(hu.elte.orai.matrix.OraiMatrixReducer.class);

		// TODO: specify output types
		job.setOutputKeyClass(Text.class);
		job.setOutputValueClass(Text.class);

		// TODO: specify input and output DIRECTORIES (not files)
		FileInputFormat.setInputPaths(job, new Path("MatrixInput"));
		FileOutputFormat.setOutputPath(job, new Path("MatrixOraiOutput"));
		
		FileSystem fs;
		try {
			fs = FileSystem.get(conf);
			if (fs.exists(new Path("MatrixOraiOutput")))
				fs.delete(new Path("MatrixOraiOutput"),true);
		} catch (IOException e1) {
			e1.printStackTrace();
		}

		if (!job.waitForCompletion(true))
			return;
	}

}
