package hu.elte.orai.matrix;

import java.io.IOException;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.io.LongWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.Mapper;
import org.apache.hadoop.mapreduce.lib.input.FileSplit;

public class OraiMatrixMapper extends Mapper<LongWritable, Text, Text, Text> {
	private final Text mapKey = new Text("");
	private final Text mapValue = new Text("");

	public void map(LongWritable ikey, Text ivalue, Context context) throws IOException, InterruptedException {
		Configuration conf = context.getConfiguration();
		
		FileSplit filesplit = (FileSplit)context.getInputSplit();
		String filename = filesplit.getPath().getName();
		
		String[] columns = ivalue.toString().split("\\s");	//0-sorszam, 1...-ertekek

		String[] Anxm = conf.get("Anxm").split("x");
		String[] Bnxm = conf.get("Bnxm").split("x");
		String sorszam = columns[0];
		
		//sorok
		if (filename.equals(conf.get("left"))) {
			int maxColumn = Integer.parseInt(Anxm[0]);
			int maxRow = Integer.parseInt(Bnxm[0]);		//gyanus: Bnxm[0]
			
			for (int j=1; j<=maxColumn; j++) {
				for (int i=1; i<=maxRow; i++) {
					mapKey.set(sorszam+","+String.valueOf(i));
					mapValue.set("A,"+String.valueOf(j)+","+String.valueOf(columns[j]));
					context.write(mapKey,mapValue);
				}
			}
		//oszlop
		} else if (filename.equals(conf.get("right"))) {
			int maxColumn = Integer.parseInt(Bnxm[0]);
			int AmaxRow = Integer.parseInt(Anxm[1]);
			
			for (int j=1; j<=maxColumn; j++) {
				for (int i=1; i<=AmaxRow; i++) {
					mapKey.set(String.valueOf(i)+","+String.valueOf(j));
					mapValue.set("B,"+String.valueOf(sorszam)+","+String.valueOf(columns[j]));
					context.write(mapKey, mapValue);
				}
			}
		}

	}

}
