package hu.elte.orai.matrix;

import java.io.IOException;
import java.util.HashMap;

import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.Reducer;

public class OraiMatrixReducer extends Reducer<Text, Text, Text, Text> {
	private Text resValue = new Text("");

	public void reduce(Text _key, Iterable<Text> values, Context context) throws IOException, InterruptedException {
		
		HashMap<Integer,Integer> hashA = new HashMap<Integer, Integer>();
		HashMap<Integer,Integer> hashB = new HashMap<Integer, Integer>();
		
		String[] param;
		// process values
		for (Text val : values) {
			param = val.toString().split(",");
			if (param[0].equals("A")) {
				hashA.put(Integer.parseInt(param[1]), Integer.parseInt(param[2]));
			} else {
				hashB.put(Integer.parseInt(param[1]), Integer.parseInt(param[2]));
			}
		}
		
		int n = Integer.parseInt(context.getConfiguration().get("Anxm").split("x")[0]);
		int result = 0;
		for (int i=1; i<=n; i++) {
			result += hashA.get(i)*hashB.get(i);
		}
		
		resValue.set(Integer.toString(result));
		context.write(_key, resValue);
		
	}

}
