package hu.elte.grepOrai;

import java.io.IOException;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.fs.FileSystem;
import org.apache.hadoop.fs.Path;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.Job;
import org.apache.hadoop.mapreduce.lib.input.FileInputFormat;
import org.apache.hadoop.mapreduce.lib.output.FileOutputFormat;

public class GrepOraiDriver {

	public static void main(String[] args) throws Exception {
		Configuration conf = new Configuration();
		conf.set("text",args[0]);
		
		Job job = Job.getInstance(conf, "JobName");
		job.setJarByClass(hu.elte.grepOrai.GrepOraiDriver.class);
		job.setMapperClass(hu.elte.grepOrai.GrepOraiMapper.class);
		
		job.setNumReduceTasks(0);

		// TODO: specify a reducer
//		job.setReducerClass(Reducer.class);

		// TODO: specify output types
		job.setOutputKeyClass(Text.class);
		job.setOutputValueClass(Text.class);

		// TODO: specify input and output DIRECTORIES (not files)
		FileInputFormat.setInputPaths(job, new Path(args[1]));
		FileOutputFormat.setOutputPath(job, new Path("grepOraiOut"));
		
		FileSystem fs;
		try {
			fs = FileSystem.get(conf);
			if (fs.exists(new Path("grepOraiOut")))
				fs.delete(new Path("grepOraiOut"),true);
		} catch (IOException e1) {
			e1.printStackTrace();
		}

		if (!job.waitForCompletion(true))
			return;
	}

}
