package hu.elte.bigdata;

import java.io.IOException;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.fs.FileSystem;
import org.apache.hadoop.fs.Path;
import org.apache.hadoop.io.IntWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.Job;
import org.apache.hadoop.mapreduce.lib.input.FileInputFormat;
import org.apache.hadoop.mapreduce.lib.output.FileOutputFormat;

public class Gyak2Driver {

	public static void main(String[] args) throws Exception {
		Configuration conf = new Configuration();
		Job job = Job.getInstance(conf, "JobName");
		job.setJarByClass(hu.elte.bigdata.Gyak2Driver.class);
		job.setMapperClass(hu.elte.bigdata.Gyak2Mapper.class);

		job.setCombinerClass(hu.elte.bigdata.Gyak2Reducer.class);
		job.setReducerClass(hu.elte.bigdata.Gyak2Reducer.class);

		// TODO: specify output types
		job.setOutputKeyClass(Text.class);
		job.setOutputValueClass(IntWritable.class);

		// TODO: specify input and output DIRECTORIES (not files)
		FileInputFormat.setInputPaths(job, new Path("input.txt"));
		FileOutputFormat.setOutputPath(job, new Path("gyak2out"));
		
		FileSystem fs;
		try {
			fs = FileSystem.get(conf);
			if (fs.exists(new Path("gyak2out")))
				fs.delete(new Path("gyak2out"),true);
		} catch (IOException e1) {
			e1.printStackTrace();
		}

		if (!job.waitForCompletion(true))
			return;
	}

}
